#include<pthread.h>	
typedef struct jobs_queue jobs_queue;
struct jobs_queue{
	int fd;
	char key[260];
	char value[266*1024];
	char message[1024];
	char messagetype[10];
	
	jobs_queue * next;
};

typedef struct kvcache_data kvcache_data;
struct kvcache_data{
	int chance;
	char key[300];
	char value[256*1024+10];
};

typedef struct kvstore_data kvstore_data;
struct kvstore_data{
	char key[300];
	char value[256*1024+10];
};

typedef struct tpool tpool_t;
struct tpool {
	kvcache_data **t;
	int *repl;
	pthread_mutex_t* cache_lock;   
    pthread_mutex_t  work_mutex;
    pthread_cond_t   work_cond;
    pthread_cond_t   working_cond;
    size_t           working_cnt;
    size_t           thread_cnt;
    jobs_queue * head;
    jobs_queue *tail;
    int             stop;
};
