#include<stdio.h>
#include<stdlib.h>
#include<string.h>
#include<unistd.h>
#include "jobs.h"
void getFileName(char * fname,long int x){
	char id[5];
	sprintf(id,"%ld",x);
	strcpy(fname,"data/kv_");
	strcat(fname,id);
	strcat(fname,".bin");
	

}
void getTempFileName(char * fname,long int x){
	char id[5];
	sprintf(id,"%ld",x);
	strcpy(fname,"data/temp_");
	strcat(fname,id);
	strcat(fname,".bin");
	

}

int deleteFromFile(char *key){
	kvstore_data *store=(kvstore_data *)malloc(sizeof(kvstore_data));
	char fname[17],temp[17];
	int flag=0;
	getFileName(fname,strlen(key));
	getTempFileName(temp,strlen(key));
	FILE *fp;
	if( access( fname, F_OK ) != -1 ){
		fp=fopen(fname,"rb");
	}
	else{
		free(store);
		return 0;
	}
	FILE *tempfp=fopen(temp,"wb");
	
	if(fp==NULL || tempfp==NULL){
		printf("ERROR:error opening file\n");
	}
	while(fread(store,sizeof(kvstore_data),1,fp)){
		if(strcmp(store->key,key)){
				fwrite(store,sizeof(kvstore_data),1,tempfp);
		}
		else{
			flag=1;
		}
	}
	/*fread(store,sizeof(kvstore_data),1,fp);
	if(strcmp(store->key,key))
				fwrite(store,sizeof(kvstore_data),1,tempfp);
		*/
	fclose(fp);
	fclose(tempfp);
	remove(fname);
	rename(temp,fname);
	return flag;
}


int dumpToFile(kvcache_data *cache){
	kvstore_data *store=(kvstore_data *)malloc(sizeof(kvstore_data));
	strcpy(store->key,cache->key);
	strcpy(store->value,cache->value);
	char fname[17];
	getFileName(fname,strlen(cache->key));	
	deleteFromFile(cache->key);
	FILE *fp=fopen(fname,"ab");
	if(fp==NULL){
		printf("ERROR:error opening file\n");
		return 0;
	}
	if(!fwrite(store,sizeof(kvstore_data),1,fp)){
		printf("ERROR:Error writing file.\n");
		free(store);
		fclose(fp);
		return 0;	
	}
	else{
		free(store);
			fclose(fp);
		return 1;	
	}
	
	return 1;

}
int restoreFromFile(char *key,char *value){
	kvstore_data *store=(kvstore_data *)malloc(sizeof(kvstore_data));
	char fname[17];
	FILE *fp;
	getFileName(fname,strlen(key));
	if( access( fname, F_OK ) != -1 ){
		fp=fopen(fname,"rb");
	}
	else{
		free(store);
		return 0;
	}
	if(fp==NULL){
		printf("ERROR:error opening file\n");
	}
	while(fread(store,sizeof(kvstore_data),1,fp)){
		if(!strcmp(key,store->key)){
			strcpy(value,store->value);
			free(store);
			fclose(fp);
			return 1;
		}
	
	}
	
	return 0;
}
